﻿
using System;
using Wisej.Web;

namespace SampleDGVColumnVisibilityState
{
    public static class DGVState
    {
        public static bool IDVisible { get; set; } = true;
        public static bool FirstnameVisible { get; set; } = false;
        public static bool LastnameVisible { get; set; } = true;
        public static bool GenderVisible { get; set; } = true;
        public static bool BirthdateVisible { get; set; } = false;
    }
    public partial class Window1 : Form
    {
        public Window1()
        {
            InitializeComponent();
            dataGridView1.ColumnStateChanged += DataGridView1_ColumnStateChanged;
        }

        private void DataGridView1_ColumnStateChanged(object sender, DataGridViewColumnStateChangedEventArgs e)
        {
            if (e.Column.Name == "IDCol")
                DGVState.IDVisible = !DGVState.IDVisible;

            else if (e.Column.Name == "FirstnameCol")
                DGVState.FirstnameVisible = !DGVState.FirstnameVisible;

            else if (e.Column.Name == "LastnameCol")
                DGVState.LastnameVisible = !DGVState.LastnameVisible;

            else if (e.Column.Name == "GenderCol")
                DGVState.GenderVisible = !DGVState.GenderVisible;

            else if (e.Column.Name == "BirthdateCol")
                DGVState.BirthdateVisible = !DGVState.BirthdateVisible;

            else
                return;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            for (int i = 0; i < 10; i++)
            {
                dataGridView1.Rows.Add(i, "Firstname - " + i, "Lastname - " + i, i % 2 == 0 ? "M" : "F", DateTime.Now.AddDays(i));
            }
            InitializeVisibility();
        }

        private void InitializeVisibility()
        {
            IDCol.Visible = DGVState.IDVisible;
            FirstnameCol.Visible = DGVState.FirstnameVisible;
            LastnameCol.Visible = DGVState.LastnameVisible;
            GenderCol.Visible = DGVState.GenderVisible;
            BirthdateCol.Visible = DGVState.BirthdateVisible;
        }
    }
}
